=== debian/changelog ===
dde-control-center (6.0.62) unstable; urgency=medium

  * bump version to 6.0.62

 -- Deepin Packages Builder <packages@deepin.org>  Wed, 14 Aug 2024 14:42:16 +0800

dde-control-center (6.0.61) unstable; urgency=medium

  * fix: dock panel min size error(Issue: 10069)(Influence: can adjust dock's min size)

 -- Deepin Packages Builder <packages@deepin.org>  Tue, 06 Aug 2024 15:45:27 +0800

dde-control-center (6.0.60) unstable; urgency=medium

  * fix: Fixed the problem that the icon cannot be retrieved from the system monitor (#1661)(issue: 9833)
  * fix: Add screenshot plug-in icon (#1662)(Issue: 9944)

 -- zyz <zhaoyingzhen@uniontech.com>  Wed, 31 Jul 2024 14:48:00 +0800

dde-control-center (6.0.59) unstable; urgency=medium

  * fix: module object name setting error (#1655)(Influence: module can jump normally)
  * fix: remove some shortcuts(Issue: 9599)
  * fix: Fix crash when switching Light/Dark theme(Issue: 9883)

 -- zyz <zhaoyingzhen@uniontech.com>  Wed, 24 Jul 2024 14:16:00 +0800

dde-control-center (6.0.58) unstable; urgency=medium

  * chore: compatible to new dock 

 -- Wang Fei <wangfei@deepin.org>  Tue, 09 Jul 2024 11:41:02 +0800

dde-control-center (6.0.57) unstable; urgency=medium

  * feat: Add translations for dde-control-center in plymouth notifications(Issue: https://github.com/linuxdeepin/developer-center/issues/8998)
  * fix: The avatar selection interface is not adapted to dark mode(Issue: https://github.com/linuxdeepin/developer-center/issues/9440)
  * feat: add configuration for hidden icon themes(Issue: https://github.com/linuxdeepin/developer-center/issues/9024)
  * fix: Refresh dock plugins list when switch composite status(Issue: https://github.com/linuxdeepin/developer-center/issues/8995)
  * fix: crash when selecting custom avatar(Issue: https://github.com/linuxdeepin/developer-center/issues/9513)
  * fix: 规范地区名称(Issue: https://github.com/linuxdeepin/developer-center/issues/5997)

 -- Zhang kun <zhangkun2@uniontech.com>  Tue, 02 Jul 2024 10:05:16 +0800

dde-control-center (6.0.56) unstable; urgency=medium

  * chore: use GenericName if X-Deepin-Vendor is 'deepin' (linuxdeepin/developer-center#6692)

 -- zsien <quezhiyong@deepin.org>  Thu, 30 May 2024 17:39:02 +0800

dde-control-center (6.0.55) unstable; urgency=medium

  * feat: add backup updates ui(Issue: https://github.com/linuxdeepin/developer-center/issues/8626)
  * fix: data of datetime is unintialized(Issue: https://github.com/linuxdeepin/developer-center/issues/8248)

 -- Zhang Kun <zhangkun2@uniontech.com>  Thu, 23 May 2024 16:08:10 +0800

dde-control-center (6.0.54) unstable; urgency=medium

  * release 6.0.54

 -- Mike Chen <chenke@deepin.org>  Mon, 13 May 2024 15:15:21 +0800

dde-control-center (6.0.53) unstable; urgency=medium

  * fix: the config file of "showtimetofull" option has changed

 -- Yutao Meng <mengyutao@deepin.org>  Tue, 30 Apr 2024 13:14:53 +0800

dde-control-center (6.0.52) unstable; urgency=medium

  * fix: upgrade information mismatch with dark mode(Issue: https://github.com/linuxdeepin/developer-center/issues/7996)

 -- Zhang kun <zhangkun2@uniontech.com>  Fri, 26 Apr 2024 13:30:56 +0800

dde-control-center (6.0.51) unstable; urgency=medium

  * feat: Update performance mode listview style
  * fix: wrong time format

 -- Wang Fei <wangfei@deepin.org>  Wed, 24 Apr 2024 19:07:10 +0800

dde-control-center (6.0.50) unstable; urgency=medium

  * release 6.0.50

 -- Mike Chen <chenke@deepin.org>  Mon, 22 Apr 2024 09:36:57 +0800

dde-control-center (6.0.49) unstable; urgency=medium

  * fix: adjust configure for dock module temporarily
  * fix: space between lang and country 

 -- Wang Fei <wangfei@deepin.org>  Mon, 15 Apr 2024 17:40:26 +0800

dde-control-center (6.0.48) unstable; urgency=medium

  * chore: remove show recent apps in dock settings 
  * fix: wrong long date format
  * chore: tab indicator radius tweak
  * fix: cannot search parenthese 

 -- Wang Fei <wangfei@deepin.org>  Tue, 02 Apr 2024 10:04:37 +0800

dde-control-center (6.0.47) unstable; urgency=medium

  * fix: ui flash when switching power subpage

 -- Wang Fei <wangfei@deepin.org>  Wed, 20 Mar 2024 16:36:48 +0800

dde-control-center (6.0.46) unstable; urgency=medium

  * fix: ui flash when switching power subpage 
  * Revert "fix: type(defult)"

 -- wangfei <wangfei@deepin.org>  Fri, 15 Mar 2024 10:05:46 +0800

dde-control-center (6.0.45) unstable; urgency=medium

  * fix: grand search can not search dcc modules
  * fix: hover index not repaint
  * fix: type(defult)
  * fix: The width of bottom button is too long
  * fix: version info data source not consistent
  * fix(PersonalizationThemeList): wrong margins

 -- Yutao Meng <mengyutao@deepin.org>  Mon, 04 Mar 2024 16:46:01 +0800

dde-control-center (6.0.44) unstable; urgency=medium

  * fix: typo compositor
  * chore: remove code for gamma control
  * fix(CustomShortcut): file chooser is opened when Enter pressed
  * fix: wrong tab index
  * fix: listview not show item backgound when normal
  * fix: set all mime type
  * chore: mask linglong-upgrade.service together

 -- wangfei <wangfei@deepin.org>  Wed, 31 Jan 2024 09:34:03 +0800

dde-control-center (6.0.43) unstable; urgency=medium

  * feat: make plugin-display works in treeland

 -- rewine <luhongxu@deepin.org>  Mon, 22 Jan 2024 23:23:44 +0800

dde-control-center (6.0.42) unstable; urgency=medium

  *  chore: remove Cooperation in display plugin (https://github.com/linuxdeepin/developer-center/issues/7023)

 -- chenhongtao <chenhongtao@deepin.org>  Mon, 22 Jan 2024 17:22:42 +0800

dde-control-center (6.0.41) unstable; urgency=medium

  * fix: time format error （https://github.com/linuxdeepin/developer-center/issues/6995）

 -- chenhongtao <chenhongtao@deepin.org>  Mon, 22 Jan 2024 09:54:17 +0800

dde-control-center (6.0.40) unstable; urgency=medium

  * fix: block some plugins under treeland
  * fix: wait for http event finished when join internal channel
  * fix: extra button too wide

